require 'class'

-- FIELDS
local _Visible = true

-- CONSTRUCTOR
local M=class(function(self, text, x, y, width, height, func, args)
	-- Store arguments
	self.text = text
	self.X = x
	self.Y = y
	self.width = width
	self.height = height
	self.func = func
	self.args = args
	-- Calculate text size
	local font = love.graphics.newFont()
	self.textWidth = font:getWidth(text)
	self.textHeight = font:getHeight(text)
end)

-- ACCESSORS

-- OPERATIONS

-- STAGE FRAMEWORK
function M:setVisible(visible)
	_Visible = visible
end

function M:update(dt)
end

function M:draw()
	if _Visible then
		love.graphics.setColor(0, 200, 255, 255)
		love.graphics.rectangle("fill", self.X, self.Y, self.width, self.height)
		love.graphics.setColor(0, 0, 0, 255)
		love.graphics.print(self.text, self.X + (self.width / 2) - (self.textWidth / 2), self.Y + (self.height / 2) - (self.textHeight / 2))
	end
end

function M:mousepressed(x, y, button)
	if x > self.X and x < self.X + self.width and y > self.Y and y < self.Y + self.height then
		if self.func then
			if self.args then
				self.func(unpack(self.args))
			else
				self.func()
			end
		end
	end
end

function M:mousereleased(x, y, button)
end

return M
