-- GLOBAL REQUIRES
local AppManager = require 'appmanager'
local AppMediator = require 'appmediator'

-- GLOBALS
_AppManager = {}
_AppMediator = AppMediator()
-- TODO 0 Move below
_BulletDrawable = nil
_BulletList = {}

-- FIELDS
local _StageList = {}
local _ControllerList = {}
local _StageManager = {}

-- LOVE CALLBACKS
function love.load()
	_AppManager = AppManager(_StageList, _ControllerList)
	_StageManager = _AppManager:getStageManager()
end

function love.update(dt)
	-- Update the stage
	_StageManager:update(dt)
	-- Call "update" on all stage elements
	for iter = 1, #_StageList, 1 do
		_StageList[iter]:update(dt)
	end
end

function love.draw()
	-- Call "draw" on all stage elements
	for iter = 1, #_StageList, 1 do
		_StageList[iter]:draw()
	end
end

function love.mousepressed(x, y, button)
	-- Tell everything on the stage about a mouse down event
	for iter = 1, #_StageList, 1 do
		_StageList[iter]:mousepressed(x, y, button)
	end
end

function love.mousereleased(x, y, button)
	-- Tell everything on the stage about a mouse up event
	for iter = 1, #_StageList, 1 do
		_StageList[iter]:mousereleased(x, y, button)
	end
end

function love.keypressed(key, isrepeat)
	-- Tell all the controllers about a keypressed event
	for iter = 1, #_ControllerList, 1 do
		_ControllerList[iter]:keypressed(key, isrepeat)
	end
end

function love.keyreleased(key)
	-- Tell all the controllers about a keyreleased event
	for iter = 1, #_ControllerList, 1 do
		_ControllerList[iter]:keyreleased(key)
	end
end

function love.focus(f)

end

function love.quit()

end