require 'class'
local ToggleLabel = require 'togglelabel'
local Button = require 'button'

-- FIELDS
local _StartButton = {}
local _DeselectButton = {}
local _SelectAllButton = {}
local _UI = {}
local _ToggleLableList = {}

-- CONSTRUCTOR
local M=class(function(self)
	_StartButton = Button("Start", 600, 550, 60, 20, OnStartButtonClick)
	_DeselectButton = Button("Deselect All", 500, 550, 90, 20, OnDeselectButtonClick)
	_SelectAllButton = Button("Select All", 400, 550, 66, 20, OnSelsectAllButtonClick)
    table.insert(_UI, _StartButton)
    table.insert(_UI, _DeselectButton)
    table.insert(_UI, _SelectAllButton)
    for Iter, Filename in ipairs(_AppMediator:getAvailableTanks()) do
        local dashPOS = string.find(Filename, "-") + 1
        local aToggleLabel = ToggleLabel(string.sub(Filename, dashPOS), Filename, 200, Iter * 20, 120, 15, true)
        table.insert(_ToggleLableList, aToggleLabel)
        table.insert(_UI, aToggleLabel)
    end
end)

-- ACCESSOR
function M:getUI()
	return _UI
end

-- STAGE FRAMEWORK
function M:update(dt)
end

function M:keypressed(key, isrepeat)
end

function M:keyreleased(key)
end

-- LOGIC
function OnStartButtonClick()
	local playerList = {}
	for Iter = 1, #_ToggleLableList, 1 do
		if _ToggleLableList[Iter]:isActive() then
			table.insert(playerList, _ToggleLableList[Iter]:getData())
		end
	end
	 _AppManager:startGame(playerList)
end

function OnDeselectButtonClick()
    for Iter = 1, #_ToggleLableList, 1 do
        _ToggleLableList[Iter]:setActive(false)
    end
end

function OnSelsectAllButtonClick()
    for Iter = 1, #_ToggleLableList, 1 do
        _ToggleLableList[Iter]:setActive(true)
    end
end

return M
