require 'class'

-- FIELDS
local _Visible = true

-- CONSTRUCTOR
local M=class(function(self, text, data, x, y, width, height, active)
	self.text = text
	self.data = data
	self.X = x
	self.Y = y
	self.width = width
	self.height = height
	self.active = active
end)

-- OPERATIONS
function M:isActive()
	return self.active
end

function M:getData()
	return self.data
end

function M:setActive(value)
	self.active = value
end

-- STAGE FRAMEWORK
function M:setVisible(visible)
	_Visible = visible
end

function M:update(dt)
end

function M:draw()
	if _Visible then
		if self.active then
			love.graphics.setColor(0, 255, 0, 255)
		else
			love.graphics.setColor(255, 0, 0, 255)
		end
		love.graphics.rectangle("fill", self.X, self.Y, self.width, self.height)
		love.graphics.setColor(0, 0, 0, 255)
		love.graphics.print(self.text, self.X, self.Y)
	end
end

function M:mousepressed(x, y, button)
	if x > self.X and x < self.X + self.width and y > self.Y and y < self.Y + self.height then
		if self.active then
			self.active = false
		else
			self.active = true
		end
	end
end

function love.mousereleased(x, y, button)
end

return M
